scala

# StringContext

###
Related Docs: object StringContext | package scala

#### case class StringContext(parts: String*) extends Product with Serializable

This class provides the basic mechanism to do String Interpolation. String Interpolation allows users to embed variable references directly in *processed* string literals. Here's an example:

    val name = "James"
    println(s"Hello, $name")  // Hello, James

Any processed string literal is rewritten as an instantiation and method call against this class. For example:

    s"Hello, $name"

is rewritten to be:

    StringContext("Hello, ", "").s(name)

By default, this class provides the `raw`, `s` and `f` methods as available interpolators.

To provide your own string interpolator, create an implicit class which adds a method to `StringContext`. Here's an example:

    implicit class JsonHelper(private val sc: StringContext) extends AnyVal {
      def json(args: Any*): JSONObject = ...
    }
    val x: JSONObject = json"{ a: $a }"

Here the `JsonHelper` extension class implicitly adds the `json` method to `StringContext` which can be used for `json` string literals.

parts

  The parts that make up the interpolated string, without the expressions that get inserted by interpolation.

Source
  StringContext.scala
Since

  2.10.0

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. StringContext
2. Serializable
3. Serializable
4. Product
5. Equals
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new StringContext(parts: String*)

   parts

     The parts that make up the interpolated string, without the expressions that get inserted by interpolation.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from StringContext to any2stringadd[StringContext] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (StringContext, B)

   Implicit information
     This member is added by an implicit conversion from StringContext to ArrowAssoc[StringContext] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def checkLengths(args: Seq[Any]): Unit

   Checks that the length of the given argument `args` is one less than the number of `parts` supplied to the enclosing `StringContext`.

   Checks that the length of the given argument `args` is one less than the number of `parts` supplied to the enclosing `StringContext`.

   Exceptions thrown

     `IllegalArgumentException` if this is not the case.

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @HotSpotIntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### def ensuring(cond: (StringContext) ⇒ Boolean, msg: ⇒ Any): StringContext

   Implicit information
     This member is added by an implicit conversion from StringContext to Ensuring[StringContext] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (StringContext) ⇒ Boolean): StringContext

    Implicit information
      This member is added by an implicit conversion from StringContext to Ensuring[StringContext] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): StringContext

    Implicit information
      This member is added by an implicit conversion from StringContext to Ensuring[StringContext] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): StringContext

    Implicit information
      This member is added by an implicit conversion from StringContext to Ensuring[StringContext] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

14. #### macro def f[A >: Any](args: A*): String

    The formatted string interpolator.

    The formatted string interpolator.

    It inserts its arguments between corresponding parts of the string context. It also treats standard escape sequences as defined in the Scala specification. Finally, if an interpolated expression is followed by a `parts` string that starts with a formatting specifier, the expression is formatted according to that specifier. All specifiers allowed in Java format strings are handled, and in the same way they are treated in Java.

    For example:

        val height = 1.9d
        val name = "James"
        println(f"$name%s is $height%2.2f meters tall")  // James is 1.90 meters tall

    Exceptions thrown

      `IllegalArgumentException` if the number of `parts` in the enclosing `StringContext` does not exceed the number of arguments `arg` by exactly 1.

      if a `parts` string contains a backslash (`\`) character that does not start a valid escape sequence. Note: The `f` method works by assembling a format string from all the `parts` strings and using `java.lang.String.format` to format all arguments with that format string. The format string is obtained by concatenating all `parts` strings, and performing two transformations:

      1. Let a _formatting position_ be a start of any `parts` string except the first one. If a formatting position does not refer to a `%` character (which is assumed to start a format specifier), then the string format specifier `%s` is inserted. 2. Any `%` characters not in formatting positions must begin one of the conversions `%%` (the literal percent) or `%n` (the platform-specific line separator).

15. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from StringContext to StringFormat[StringContext] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

17. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

18. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

20. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

21. #### val parts: String*

    The parts that make up the interpolated string, without the expressions that get inserted by interpolation.

22. #### def raw(args: Any*): String

    The raw string interpolator.

    The raw string interpolator.

    It inserts its arguments between corresponding parts of the string context. As opposed to the simple string interpolator `s`, this one does not treat standard escape sequences as defined in the Scala specification.

    For example, the raw processed string `raw"a\nb"` is equal to the scala string `"a\\nb"`.

    Note: Even when using the raw interpolator, Scala will preprocess unicode escapes. For example:

        scala> raw"\u0023"
        res0: String = #

    Exceptions thrown

      `IllegalArgumentException` if the number of `parts` in the enclosing `StringContext` does not exceed the number of arguments `arg` by exactly 1.

23. #### def s(args: Any*): String

    The simple string interpolator.

    The simple string interpolator.

    It inserts its arguments between corresponding parts of the string context. It also treats standard escape sequences as defined in the Scala specification. Here's an example of usage:

        val name = "James"
        println(s"Hello, $name")  // Hello, James

    In this example, the expression $name is replaced with the `toString` of the variable `name`. The `s` interpolator can take the `toString` of any arbitrary expression within a `${}` block, for example:

        println(s"1 + 1 = ${1 + 1}")

    will print the string `1 + 1 = 2`.

    Exceptions thrown

      `IllegalArgumentException` if the number of `parts` in the enclosing `StringContext` does not exceed the number of arguments `arg` by exactly 1.

      `StringContext.InvalidEscapeException` if a `parts` string contains a backslash (`\`) character that does not start a valid escape sequence.

24. #### def standardInterpolator(process: (String) ⇒ String, args: Seq[Any]): String

25. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

26. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### def →[B](y: B): (StringContext, B)

    Implicit information
      This member is added by an implicit conversion from StringContext to ArrowAssoc[StringContext] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from StringContext to any2stringadd[StringContext]

### Inherited by implicit conversion StringFormat from StringContext to StringFormat[StringContext]

### Inherited by implicit conversion Ensuring from StringContext to Ensuring[StringContext]

### Inherited by implicit conversion ArrowAssoc from StringContext to ArrowAssoc[StringContext]

### Ungrouped